"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resetUserPassword = exports.updateUserDoc = exports.updateUserExtended = exports.updateChannelExtended = exports.updateThingDoc = exports.updateThingExtended = exports.updateAssetDoc = exports.updateAssetExtended = exports.ensureEntityConf = exports.reqEntityConf = exports.presenceFor = exports.fromChannel = exports.getUnitFromChannel = exports.getChannelAndTypeFromRid = exports.getChannelTypeFromChannel = void 0;

var _extendedDsClient = require("extended-ds-client");

var R = _interopRequireWildcard(require("ramda"));

var _subSeconds = _interopRequireDefault(require("date-fns/fp/subSeconds"));

var _get = _interopRequireDefault(require("lodash/fp/get"));

var _transforms = require("../transforms");

var _dmUtils = require("../dm-utils");

var _dataUtils = require("../data-utils");

var _com = require("./com");

var _api = require("./api");

var _unit = require("../unit");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * Get a channel's ChannelType record from a channel record.
 * @func
 * @static
 * @param {type} rid A channel record
 * @returns {Promise} A Promise of a type record
 */
var getChannelTypeFromChannel = function getChannelTypeFromChannel(_ref) {
  var id, _ref2, _ref3, type;

  return regeneratorRuntime.async(function getChannelTypeFromChannel$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          id = _ref.type;

          if (id) {
            _context.next = 3;
            break;
          }

          return _context.abrupt("return", undefined);

        case 3:
          _context.next = 5;
          return regeneratorRuntime.awrap((0, _api.readChannelType)({
            rids: [],
            filter: ['=', 'id', id]
          }));

        case 5:
          _ref2 = _context.sent;
          _ref3 = _slicedToArray(_ref2, 1);
          type = _ref3[0];
          return _context.abrupt("return", type);

        case 9:
        case "end":
          return _context.stop();
      }
    }
  });
};
/**
 * Get a channel record and its channel type record (if any).
 * @func
 * @static
 * @param {type} rid A channel rid
 * @returns {Promise} A Promise of an object with the type record and the channel record.
 */


exports.getChannelTypeFromChannel = getChannelTypeFromChannel;

var getChannelAndTypeFromRid = function getChannelAndTypeFromRid(rid) {
  var _ref4, _ref5, channel, type;

  return regeneratorRuntime.async(function getChannelAndTypeFromRid$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _context2.next = 2;
          return regeneratorRuntime.awrap((0, _api.readChannel)({
            rids: [rid]
          }));

        case 2:
          _ref4 = _context2.sent;
          _ref5 = _slicedToArray(_ref4, 1);
          channel = _ref5[0];
          _context2.next = 7;
          return regeneratorRuntime.awrap(getChannelTypeFromChannel(channel));

        case 7:
          type = _context2.sent;
          return _context2.abrupt("return", channel ? {
            channel: channel,
            type: type
          } : undefined);

        case 9:
        case "end":
          return _context2.stop();
      }
    }
  });
};

exports.getChannelAndTypeFromRid = getChannelAndTypeFromRid;

var getUnitFromChannel = function getUnitFromChannel(channelRid) {
  var channelAndType, type, unit;
  return regeneratorRuntime.async(function getUnitFromChannel$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          _context3.next = 2;
          return regeneratorRuntime.awrap(getChannelAndTypeFromRid(channelRid));

        case 2:
          channelAndType = _context3.sent;

          if (channelAndType) {
            _context3.next = 5;
            break;
          }

          return _context3.abrupt("return", undefined);

        case 5:
          type = channelAndType.type;

          if (type) {
            _context3.next = 8;
            break;
          }

          return _context3.abrupt("return", undefined);

        case 8:
          unit = type.unit;
          return _context3.abrupt("return", unit);

        case 10:
        case "end":
          return _context3.stop();
      }
    }
  });
};
/**
 * Main function for subscribing to and getting historic data from a channel.
 * @func
 * @static
 * @param {object} options
 * @param {string} options.rid
 * @param {boolean} options.last If to include last value
 * @param {number} options.tail How many historic values to fetch
 * @param {number} options.ttl Time to live as seconds
 * @param {function} options.cb Callback (for one/each value)
 * @param {function} options.historyCb Callback for history batch
 * @param {boolean} options.noSub If not to subscribe
 * @param {string} options.path Extract a path from each message
 * @param {boolean} options.noTsToDate No Date conversion
 * @param {string[]} options.projection
 * @param {string} options.busChannel Raw channel (instead of rid)
 * @param {object} options.typeDoc Already fetched ChannelType for channel
 * @returns {function|undefined} Unsubscribe function if relevant
 */


exports.getUnitFromChannel = getUnitFromChannel;

var fromChannel = function fromChannel(_ref6) {
  var rid, last, tail, ttl, cb, historyCb, from, to, noSub, path, noTsToDate, _ref6$projection, projection, busChannel, ascending, typeDoc, converter, toUnit, unit, _getConverter, _getConverter2, fixMsg, dhPromise, callback, channel, unsubscribe;

  return regeneratorRuntime.async(function fromChannel$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          rid = _ref6.rid, last = _ref6.last, tail = _ref6.tail, ttl = _ref6.ttl, cb = _ref6.cb, historyCb = _ref6.historyCb, from = _ref6.from, to = _ref6.to, noSub = _ref6.noSub, path = _ref6.path, noTsToDate = _ref6.noTsToDate, _ref6$projection = _ref6.projection, projection = _ref6$projection === void 0 ? ['pl', 'ts', 'ct', 'sig'] : _ref6$projection, busChannel = _ref6.busChannel, ascending = _ref6.ascending, typeDoc = _ref6.typeDoc;

          if (!(rid === undefined && busChannel === undefined)) {
            _context4.next = 3;
            break;
          }

          return _context4.abrupt("return", undefined);

        case 3:
          converter = R.identity;

          if (!_extendedDsClient.ds.unitSettings) {
            _context4.next = 15;
            break;
          }

          if (!typeDoc) {
            _context4.next = 9;
            break;
          }

          _context4.t0 = typeDoc.unit;
          _context4.next = 12;
          break;

        case 9:
          _context4.next = 11;
          return regeneratorRuntime.awrap(getUnitFromChannel(rid));

        case 11:
          _context4.t0 = _context4.sent;

        case 12:
          unit = _context4.t0;
          toUnit = unit;

          if (unit) {
            _getConverter = (0, _unit.getConverter)(unit, _extendedDsClient.ds.unitSettings);
            _getConverter2 = _slicedToArray(_getConverter, 2);
            toUnit = _getConverter2[0];
            converter = _getConverter2[1];
            console.log('Created converter:', unit, '->', toUnit);

            if (toUnit && converter) {
              converter = (0, _unit.convertMaybeTiip)(converter);
            }
          }

        case 15:
          fixMsg = R.compose(R.when(function () {
            return path !== undefined;
          }, (0, _get["default"])(path)), R.when(function () {
            return !noTsToDate;
          }, _dmUtils.evolveTsToDate), _dmUtils.ensureTsV3);

          if (!(last || tail || from || to || ttl || historyCb || noSub || ascending)) {
            _context4.next = 20;
            break;
          }

          dhPromise = (0, _api.dataHistoryRead)(_objectSpread({
            channel: rid,
            from: (0, _dmUtils.dateToUtcTs)(from),
            to: (0, _dmUtils.dateToUtcTs)(to)
          }, ttl ? {
            from: (0, _dmUtils.dateToTs)((0, _subSeconds["default"])(ttl)(new Date()))
          } : {}, {}, tail || last ? {
            limit: tail || Number(last)
          } : {}, {
            ascending: ascending,
            projection: projection // TODO: This is problematic together with fix and converter ?? Or not?

          })).then(function (results) {
            var data = R.compose(R.when(function () {
              return !path || path.startsWith('pl');
            }, converter), R.map(fixMsg), R.when(function () {
              return !ascending;
            }, R.reverse))(results);
            if (historyCb) historyCb(data);else if (cb) data.map(cb);
            return data;
          }); // if this is a history fetch (no subscribing) -> return history data promise

          if (!noSub) {
            _context4.next = 20;
            break;
          }

          return _context4.abrupt("return", dhPromise);

        case 20:
          if (noSub) {
            _context4.next = 26;
            break;
          }

          callback = R.compose(cb, R.when(function () {
            return !path || path.startsWith('pl');
          }, converter), fixMsg);
          channel = busChannel || (0, _com.ridToBusChannel)(rid);
          (0, _com.sub)(callback, channel);

          unsubscribe = function unsubscribe() {
            return (0, _com.unsub)(channel, callback);
          };

          return _context4.abrupt("return", unsubscribe);

        case 26:
          return _context4.abrupt("return", undefined);

        case 27:
        case "end":
          return _context4.stop();
      }
    }
  });
};

exports.fromChannel = fromChannel;

var presenceFor = function presenceFor(_ref7) {
  var id = _ref7.id,
      cb = _ref7.cb,
      noSub = _ref7.noSub;
  if (id === undefined) return undefined;
  (0, _api.presenceListClients)({}).then(function (reply) {
    return cb(reply.includes(id));
  });

  if (!noSub) {
    var _callback = R.o(cb, R.prop('login'));

    var _channel = "presence/".concat(id);

    (0, _com.sub)(_callback, _channel);

    var unsubscribe = function unsubscribe() {
      return (0, _com.unsub)(_channel, _callback);
    };

    return unsubscribe; // notify caller about a subscription made
  }

  return undefined;
};

exports.presenceFor = presenceFor;
var reqEntityConf = R.curry(function (id, entityRid) {
  return (0, _api.readConfiguration)(_objectSpread({
    entities: (0, _transforms.ensureArray)(entityRid),
    rids: []
  }, id ? {
    filter: ['=', 'id', id]
  } : {})).then(function (results) {
    return id && typeof entityRid === 'string' ? results[0] : results;
  });
});
exports.reqEntityConf = reqEntityConf;

var ensureEntityConf = function ensureEntityConf(id, entityRid, conf) {
  var result, newConf;
  return regeneratorRuntime.async(function ensureEntityConf$(_context5) {
    while (1) {
      switch (_context5.prev = _context5.next) {
        case 0:
          _context5.next = 2;
          return regeneratorRuntime.awrap(reqEntityConf(id, entityRid));

        case 2:
          result = _context5.sent;

          if (!result) {
            _context5.next = 7;
            break;
          }

          _context5.next = 6;
          return regeneratorRuntime.awrap((0, _api.updateConfiguration)({
            rids: [result.rid],
            properties: conf
          }));

        case 6:
          return _context5.abrupt("return", result);

        case 7:
          _context5.next = 9;
          return regeneratorRuntime.awrap((0, _api.createConfiguration)({
            id: id,
            properties: conf
          }));

        case 9:
          newConf = _context5.sent;
          _context5.next = 12;
          return regeneratorRuntime.awrap((0, _api.addConfigurationToEntity)({
            rids: [entityRid],
            configurations: [newConf.rid]
          }));

        case 12:
          return _context5.abrupt("return", newConf);

        case 13:
        case "end":
          return _context5.stop();
      }
    }
  });
};

exports.ensureEntityConf = ensureEntityConf;

var updateAssetExtended = function updateAssetExtended(_ref8) {
  var rids = _ref8.rids,
      type = _ref8.type,
      removedChannels = _ref8.removedChannels,
      addedChannels = _ref8.addedChannels,
      removedChildren = _ref8.removedChildren,
      addedChildren = _ref8.addedChildren,
      properties = _ref8.properties;
  var promises = [];
  if (type !== undefined) promises.push((0, _api.setAssetType)({
    rids: rids,
    type: type
  })["catch"]((0, _com.logReqError)(_api.setAssetType)));
  if (!(0, _transforms.nilOrEmpty)(properties)) promises.push((0, _api.updateAsset)({
    rids: rids,
    properties: properties
  })["catch"]((0, _com.logReqError)(_api.updateAsset)));
  if (!(0, _transforms.nilOrEmpty)(removedChannels) || !(0, _transforms.nilOrEmpty)(addedChannels)) promises.push((0, _api.removeChannelFromAsset)({
    rids: rids,
    channelIds: removedChannels
  }).then(function () {
    return (0, _api.addChannelToAsset)({
      rids: rids,
      channels: addedChannels
    });
  })["catch"]((0, _com.logReqError)(_api.removeChannelFromAsset)));
  if (!(0, _transforms.nilOrEmpty)(removedChildren)) promises.push((0, _api.removeChildFromAsset)({
    rids: rids,
    children: removedChildren
  }).then(function () {
    return !(0, _transforms.nilOrEmpty)(addedChildren) ? (0, _api.addChildToAsset)({
      rids: rids,
      children: addedChildren
    }) : null;
  })["catch"]((0, _com.logReqError)(_api.removeChildFromAsset)));else if (!(0, _transforms.nilOrEmpty)(addedChildren)) promises.push((0, _api.addChildToAsset)({
    rids: rids,
    children: addedChildren
  })["catch"]((0, _com.logReqError)(_api.addChildToAsset)));
  return Promise.all(promises);
};

exports.updateAssetExtended = updateAssetExtended;

var updateAssetDoc = function updateAssetDoc(oldDoc, doc) {
  var rid = oldDoc.rid,
      oldId = oldDoc.id,
      _oldDoc$channels = oldDoc.channels,
      oldChannels = _oldDoc$channels === void 0 ? {} : _oldDoc$channels,
      _oldDoc$children = oldDoc.children,
      oldChildren = _oldDoc$children === void 0 ? [] : _oldDoc$children,
      oldType = oldDoc.type;

  var id = doc.id,
      channels = doc.channels,
      children = doc.children,
      type = doc.type,
      rest = _objectWithoutProperties(doc, ["id", "channels", "children", "type"]);

  var unchangedChannels = R.equals(oldChannels)(channels);
  var removedChildren = R.without(children)(oldChildren);
  var addedChildren = R.without(oldChildren)(children);
  return updateAssetExtended(_objectSpread({
    rids: [rid]
  }, type !== oldType ? {
    type: type
  } : {}, {}, unchangedChannels ? {} : {
    removedChannels: Object.keys(oldChannels),
    addedChannels: channels
  }, {}, R.isEmpty(removedChildren) ? {} : {
    removedChildren: removedChildren
  }, {}, R.isEmpty(addedChildren) ? {} : {
    addedChildren: addedChildren
  }, {
    properties: id !== oldId ? _objectSpread({}, rest, {
      id: id
    }) : rest
  }));
};

exports.updateAssetDoc = updateAssetDoc;

var updateThingExtended = function updateThingExtended(_ref9) {
  var rids = _ref9.rids,
      credentials = _ref9.credentials,
      type = _ref9.type,
      properties = _ref9.properties,
      removedRoles = _ref9.removedRoles,
      addedRoles = _ref9.addedRoles;
  var promises = [];
  if (type !== undefined) promises.push((0, _api.setThingType)({
    rids: rids,
    type: type
  })["catch"]((0, _com.logReqError)(_api.setThingType)));
  if (!(0, _transforms.nilOrEmpty)(properties)) promises.push((0, _api.updateThing)({
    rids: rids,
    properties: properties
  })["catch"]((0, _com.logReqError)(_api.updateThing)));
  if (!(0, _transforms.nilOrEmpty)(credentials)) promises.push( // TODO: make a loop here, for correctness?
  (0, _api.updateThingCredentials)(_objectSpread({
    rid: rids[0]
  }, credentials))["catch"]((0, _com.logReqError)(_api.updateThing)));
  if (!(0, _transforms.nilOrEmpty)(removedRoles)) promises.push((0, _api.removeRoleFromThing)({
    rids: rids,
    roles: removedRoles
  }).then(function () {
    return !(0, _transforms.nilOrEmpty)(addedRoles) ? (0, _api.addRoleToThing)({
      rids: rids,
      roles: addedRoles
    }) : null;
  })["catch"]((0, _com.logReqError)(_api.removeRoleFromThing)));else if (!(0, _transforms.nilOrEmpty)(addedRoles)) promises.push((0, _api.addRoleToThing)({
    rids: rids,
    roles: addedRoles
  })["catch"]((0, _com.logReqError)(_api.addRoleToThing)));
  return Promise.all(promises);
};

exports.updateThingExtended = updateThingExtended;

var updateThingDoc = function updateThingDoc(oldDoc, doc) {
  var rid = oldDoc.rid,
      oldId = oldDoc.id,
      _oldDoc$roles = oldDoc.roles,
      oldRoles = _oldDoc$roles === void 0 ? [] : _oldDoc$roles,
      oldType = oldDoc.type;

  var id = doc.id,
      roles = doc.roles,
      type = doc.type,
      password = doc.password,
      rest = _objectWithoutProperties(doc, ["id", "roles", "type", "password"]); // console.log('updateThingChanges:', oldDoc, doc);


  var removedRoles = R.without(roles)(oldRoles);
  var addedRoles = R.without(oldRoles)(roles);
  var hasNewCredentials = id !== oldId || password;
  return updateThingExtended(_objectSpread({
    rids: [rid]
  }, hasNewCredentials ? {
    credentials: _objectSpread({}, id !== oldId ? {
      id: id
    } : {}, {}, password ? {
      password: (0, _com.pwHash)(password)
    } : {})
  } : {}, {}, type !== oldType ? {
    type: type
  } : {}, {}, R.isEmpty(removedRoles) ? {} : {
    removedRoles: removedRoles
  }, {}, R.isEmpty(addedRoles) ? {} : {
    addedRoles: addedRoles
  }, {
    properties: id !== oldId ? _objectSpread({}, rest, {
      id: id
    }) : rest
  }));
};

exports.updateThingDoc = updateThingDoc;

var updateChannelExtended = function updateChannelExtended(rids, type, properties) {
  var promises = [];
  if (type !== undefined) promises.push((0, _api.setChannelType)({
    rids: rids,
    type: type
  })["catch"]((0, _com.logReqError)(_api.setChannelType)));
  if (!(0, _transforms.nilOrEmpty)(properties)) promises.push((0, _api.updateChannel)({
    rids: rids,
    properties: properties
  })["catch"]((0, _com.logReqError)(_api.updateChannel)));
  return Promise.all(promises);
};

exports.updateChannelExtended = updateChannelExtended;

var updateUserExtended = function updateUserExtended(_ref10) {
  var rids = _ref10.rids,
      properties = _ref10.properties,
      removedRoles = _ref10.removedRoles,
      addedRoles = _ref10.addedRoles,
      id = _ref10.id,
      password = _ref10.password;
  var promises = [];
  if (!(0, _transforms.nilOrEmpty)(properties)) promises.push((0, _api.updateUser)({
    rids: rids,
    properties: properties
  })["catch"]((0, _com.tapLogReqError)(_api.updateUser)));
  if (!(0, _transforms.nilOrEmpty)(removedRoles)) promises.push((0, _api.removeRoleFromUser)({
    rids: rids,
    roles: removedRoles
  }).then(function () {
    return !(0, _transforms.nilOrEmpty)(addedRoles) ? (0, _api.addRoleToUser)({
      rids: rids,
      roles: addedRoles
    }) : null;
  })["catch"]((0, _com.tapLogReqError)(_api.removeRoleFromUser, _api.addRoleToUser)));else if (!(0, _transforms.nilOrEmpty)(addedRoles)) promises.push((0, _api.addRoleToUser)({
    rids: rids,
    roles: addedRoles
  })["catch"]((0, _com.tapLogReqError)(_api.addRoleToUser)));
  if (id || password) rids.forEach(function (rid) {
    return promises.push((0, _api.updateUserCredentials)(_objectSpread({
      rid: rid
    }, id ? {
      id: id
    } : {}, {}, password ? {
      password: password
    } : {}))["catch"]((0, _com.tapLogReqError)(_api.updateUserCredentials)));
  });
  return Promise.all(promises);
};

exports.updateUserExtended = updateUserExtended;

var updateUserDoc = function updateUserDoc(oldDoc, doc) {
  var rid = oldDoc.rid,
      oldId = oldDoc.id,
      oldName = oldDoc.name,
      _oldDoc$roles2 = oldDoc.roles,
      oldRoles = _oldDoc$roles2 === void 0 ? [] : _oldDoc$roles2;

  var name = doc.name,
      id = doc.id,
      password = doc.password,
      roles = doc.roles,
      rest = _objectWithoutProperties(doc, ["name", "id", "password", "roles"]);

  var removedRoles = R.without(roles)(oldRoles);
  var addedRoles = R.without(oldRoles)(roles);
  return updateUserExtended(_objectSpread({
    rids: [rid]
  }, R.isEmpty(removedRoles) ? {} : {
    removedRoles: removedRoles
  }, {}, R.isEmpty(addedRoles) ? {} : {
    addedRoles: addedRoles
  }, {
    properties: name !== oldName ? _objectSpread({}, rest, {
      name: name
    }) : rest
  }, id !== oldId ? {
    id: id
  } : {}, {}, password ? {
    password: (0, _com.pwHash)(password)
  } : {}));
};

exports.updateUserDoc = updateUserDoc;

var resetPasswordHtml = function resetPasswordHtml(id, password, supportConf) {
  var supportEmail = supportConf.email,
      userCreationLink = supportConf.userCreationLink;
  var linkUrl = userCreationLink || "".concat(document.location.protocol, "//").concat(document.location.host.split('/')[0]);
  return "\n    <p>Your password at <a title=\"".concat(linkUrl, "\" href=\"").concat(linkUrl, "\">").concat(linkUrl, "</a> has been reset.</p>\n    <p>Your new credentials are:</p>\n    <p style=\"padding-left: 30px;\"><strong>id:&nbsp;").concat(id, "</strong></p>\n    <p style=\"padding-left: 30px;\"><strong>password:&nbsp;").concat(password, "</strong></p>\n    <p>You can change your password in your profile after logging in by clicking\n      your user icon in the top left corner of the screen.\n    </p>\n    <p>This mail can not be replied to. For questions, email:\n      <a href=\"mailto:").concat(supportEmail, "\">").concat(supportEmail, "</a></p>\n  ");
};

var resetUserPassword = function resetUserPassword(rid, email, supportConf) {
  var newPassword, hashedNewPassword;
  return regeneratorRuntime.async(function resetUserPassword$(_context6) {
    while (1) {
      switch (_context6.prev = _context6.next) {
        case 0:
          newPassword = (0, _dataUtils.generateString)();
          hashedNewPassword = (0, _com.pwHash)(newPassword);
          return _context6.abrupt("return", (0, _api.updateUserCredentials)({
            rid: rid,
            password: hashedNewPassword
          }).then(function () {
            if (email && (0, _dataUtils.validateEmail)(email)) {
              return (0, _api.mailerSend)({
                to: [email],
                subject: 'Password reset',
                html: resetPasswordHtml(email, newPassword, supportConf)
              });
            }

            throw new Error("".concat(email, " is not a valid email."));
          }));

        case 3:
        case "end":
          return _context6.stop();
      }
    }
  });
};

exports.resetUserPassword = resetUserPassword;